/*
 * WebApp Framework by COoL
 */

//禁用自带滚动响应
//document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);

//读取缓存图片数据
var tmpimgcache=window.localStorage.getItem('imgcache');
if(tmpimgcache)
    imgcache=tmpimgcache.split('|');

//读取本地tokenid
tokenid=window.localStorage.getItem('tokenid');

//读取本地记录的默认档案
defdocid=window.localStorage.getItem('defdocid');

//读取本地记录的默认城市
defcity=window.localStorage.getItem('defcity');

//读取本人档案ID
docselfid=window.localStorage.getItem('docselfid');

//读取本地搜索记录
var tmpsearchhistory=window.localStorage.getItem('searchhistory');
if(tmpsearchhistory)
    searchhistory=tmpsearchhistory.split('|');
else
    searchhistory=[];


//机器信息-来自插件
//device

//全局方法
String.prototype.replaceAll=function(s1,s2){
    return this.replace(new RegExp(s1,"gm"),s2);
}

//全局变量
var
    windowHeight = document.documentElement.clientHeight;
    isAndroid = (/android/gi).test(navigator.appVersion),
    isIDevice = (/iphone|ipad/gi).test(navigator.appVersion),
    isWebOS = (/webOS/gi).test(navigator.appVersion),
    hasTouch = 'ontouchstart' in window,
    START_EV = hasTouch ? 'touchstart' : 'mousedown',
    MOVE_EV = hasTouch ? 'touchmove' : 'mousemove',
    END_EV = hasTouch ? 'touchend' : 'mouseup',
    CANCEL_EV = hasTouch ? 'touchcancel' : 'mouseup';

(function(){
    //路由
    var routes = [], _his = [], _pos, _ignore;
    window.Router = {
        set_routes : function(r) { routes = r },
        history : function(index) {
            //tr('_his: '+_his.join(' >> '));
            return index <= 0 && _his.length + index - 1 >= 0 ?
                _his[_his.length + index - 1] : ''
        },
        set_ignore: function(str) {
            _ignore = new RegExp(str);
        },

        record: function(hash) {
            if(!(_ignore && _ignore.test(hash))) {
                _his[_his.length] = hash;
            }
            if (_his.length > 150) _his.slice(-100);
        },
        set_position: function(pos) {
            _pos = {};
            for (var i=0; i<pos.length; i++){
                var p = pos[i][1];
                _pos[pos[i][0]] = {
                    reLeft : new RegExp((p['leftOf'] || ['$.']).join('|')),
                    reRight : new RegExp((p['rightOf'] || ['$.']).join('|')),
                    reAbove: new RegExp((p['above'] || ['$.']).join('|')),
                    reBelow: new RegExp((p['below'] || ['$.']).join('|'))
                }
            }
        },
        get_position: function(page, lastHash) {
            //tr(_pos[page].reRight);
            //tr(lastHash);
            return !_pos[page] ? 'center':
                _pos[page].reLeft.test(lastHash) ? 'left' :
                _pos[page].reRight.test(lastHash) ? 'right' :
                _pos[page].reAbove.test(lastHash) ? 'bottom_out' :
                _pos[page].reBelow.test(lastHash) ? 'bottom': 'center';
        },
        get_back_from: function(pattern) {
            //alert(_his.join(' >> '));
            if(_his.length) {
                var hash = Router.history(-1);
                //alert(hash);
                if(hash==location.hash){
                    _his.pop();
                    hash = Router.history(-1);
                    //alert(hash);
                }
                //tr('_delhis: '+_his.join(' >> '));
                //var hash = Router.history(-1);
                if (!(new RegExp(pattern)).test(hash)) {
                    //Router.record(location.hash);
                    location.hash = hash;
                    return;
                }
            }
        },
        check_url: function(){
            __loadingcount=0;
            if(location.hash=='')
                location.hash='#startf';
            //tr('==>'+ location.hash);
            //$.event.trigger('check_url');
            //tr('_addhis: '+_his.join(' >> '));
            for (var i=0; i<routes.length; i++){
                var match, re;
                re = new RegExp(routes[i][0].replace('/', '\\\/'));
                match = re.exec(location.hash);
                if (match){
                    hideloading();
                    if(!ismember() && !($.inArray(routes[i][0],memberHashs)==-1)){
                        //无权限
                        showtips('请先登录');
                        location.hash='#login';
                        return false;
                    }
                    else {
                        Router.record(location.hash);
                        return routes[i][1](match);
                    }
                }
            }
        },
        fixhistory: function(){
            //alert(_his.join(' > '));
            if(_his.length>=3 && _his[_his.length-1]==_his[_his.length-3]){
                _his.pop();
                _his.pop();
            }
        },
        fixlasthis: function(hash){
            _his[_his.length-1]=hash;
        },
        delselfhistory: function(){
            _his.pop();
        },
        refresh: function(){
            var match, re;
            if(Router.history(-1)!=location.hash)
                Router.record(location.hash);
            //tr('_addhis: '+_his.join(' >> '));
            for (var i=0; i<routes.length; i++){
                re = new RegExp(routes[i][0].replace('/', '\\\/'));
                match = re.exec(location.hash);
                if (match) return routes[i][1](match);
            }
        }
    }
    $(window).bind('hashchange', Router.check_url);

    //模板解析
    var cache = {};
    $.tmpl = function(str, data){
        data = data || {};
        if (str[0] == '#') str = $(str).html();
        str = str.trim();
        var fn = cache[str] ||
        new Function("o", "var p=[];with(o){p.push('" +
         str.replace(/[\r\t\n]/g, " ")
         .replace(/'(?=[^%]*%})/g,"\t")
         .split("'").join("\\'")
         .split("\t").join("'")
         .replace(/{%=(.+?)%}/g, "',$1,'")
         .split("{%").join("');")
         .split("%}").join("p.push('")
         + "');}return p.join('');");
        return fn.apply(data, [data]);
    }

    $.flush_all_cache = function(){ cache = {}; }

    $.flush_cache = function(url){
        showloading('加载中');
        for (var property in cache){
            if(property.indexOf(url)>-1)
                delete cache[property];
        }
        hideloading();
    }
    
    $.getp = function(url, data, ispost, no_cache, no_loading, successfunc, failedfunc, errorfunc){
        if(!no_loading) {
            showloading('读取中');
            var cache_key = url + '::' + $.param(data);
            if (!no_cache && cache[cache_key]) {
                if ((new Date()).getTime() - cache[cache_key].__t < CACHE_EXPIRE) {
                    //$.event.trigger('ajaxComplete');
                    successfunc(cache[cache_key].__v);
                    hideloading();
                    return;
                } else {
                    delete cache[cache_key];
                }
            }
            $.ajax({
                url: url,
                type: (ispost ? 'post' : 'get'),
                cache: false,
                async: true,
                data: data,
                dataType: 'json',
                timeout: 10000,
                success: function (json) {
                    if (typeof(json.Result) === 'number' && json.Result == 200) {
                        cache[cache_key] = {
                            __t: (new Date()).getTime(),
                            __v: json
                        }
                        successfunc(json);
                    }
                    else {
                        if (typeof(failedfunc) === 'function')
                            failedfunc(json);
                        else if (json.Result == 403) {
                            showtips(json.Error);
                            location.hash = '#login';
                        }
                        else if (json.Error == "") {
                            if (DEBUG)
                                showtips("错误代码：" + json.Result);
                            else
                                showtips("系统遇到一点小问题，请稍候再试");
                        }
                        else {
                            showtips(json.Error);
                        }
                    }
                    return;
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    if (typeof(errorfunc) === 'function')
                        errorfunc(XMLHttpRequest, textStatus, errorThrown);
                    else {
                        if (XMLHttpRequest.status == 0)
                            showtips('请求超时，请检查网络连接');
                        else if (DEBUG)
                            showtips("错误代码：" + XMLHttpRequest.status);
                        else
                            showtips("系统遇到一点小问题，请稍候再试");
                    }
                    hideloading();
                },
                complete: function () {
                    hideloading();
                }
            });
        }
        else{
            var cache_key = url + '::' + $.param(data);
            if (!no_cache && cache[cache_key]) {
                if ((new Date()).getTime() - cache[cache_key].__t < CACHE_EXPIRE) {
                    //$.event.trigger('ajaxComplete');
                    successfunc(cache[cache_key].__v);
                    return;
                } else {
                    delete cache[cache_key];
                }
            }
            $.ajax({
                url: url,
                type: (ispost ? 'post' : 'get'),
                cache: false,
                async: true,
                data: data,
                dataType: 'json',
                timeout: 10000,
                success: function (json) {
                    if (typeof(json.Result) === 'number' && json.Result == 200) {
                        cache[cache_key] = {
                            __t: (new Date()).getTime(),
                            __v: json
                        }
                        successfunc(json);
                    }
                    else {
                        if (typeof(failedfunc) === 'function')
                            failedfunc(json);
                        else if (json.Result == 403) {
                            showtips(json.Error);
                            location.hash = '#login';
                        }
                        else if (json.Error == "") {
                            if (DEBUG)
                                showtips("错误代码：" + json.Result);
                            else
                                showtips("系统遇到一点小问题，请稍候再试");
                        }
                        else {
                            showtips(json.Error);
                        }
                    }
                    return;
                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    if (typeof(errorfunc) === 'function')
                        errorfunc(XMLHttpRequest, textStatus, errorThrown);
                    else {
                        if (XMLHttpRequest.status == 0)
                            showtips('请求超时，请检查网络连接');
                        else if (DEBUG)
                            showtips("错误代码：" + XMLHttpRequest.status);
                        else
                            showtips("系统遇到一点小问题，请稍候再试");
                    }
                },
                complete: function () {
                }
            });
        }
        return false;
    }
})();

var opts = {
    lines: 8, // The number of lines to draw
    length: 1, // The length of each line
    width: 5, // The line thickness
    radius: 10, // The radius of the inner circle
    corners: 1, // Corner roundness (0..1)
    rotate: 0, // The rotation offset
    color: '#000', // #rgb or #rrggbb
    speed: 1.2, // Rounds per second
    trail: 50, // Afterglow percentage
    shadow: false, // Whether to render a shadow
    hwaccel: false, // Whether to use hardware acceleration
    className: 'spinner', // The CSS class to assign to the spinner
    zIndex: 2e9, // The z-index (defaults to 2000000000)
    top: 'auto', // Top position relative to parent in px
    left: 'auto' // Left position relative to parent in px
};
var target = document.getElementById('Loading');
var spinner = new Spinner(opts).spin(target);
//显示loading
__loadingcount=0;//读取过程计数
loading=$('.loading');
loadingbg=$('.loadingbg');
var showloading = function(txt){
    __loadingcount++;
    /*if(typeof(txt) === 'string')
        $('.loading strong').text(txt);*/
    loading.show();
    loadingbg.show();
}
//隐藏loading
var hideloading = function(){
    if(--__loadingcount>0)
        return;
    __loadingcount=0;
    loadingbg.hide();
    loading.hide();
    //$('.loading strong').text('加载中');
}

//显示提示
var showtips = function(str){
    $('.tipslayout').css({bottom:'-60px',opacity:0});
    $(document.body).prepend('<div class="tipslayout"><span>'+str+'</span></div>');
    setTimeout(function(){$('.tipslayout').last().remove();},2000);
}

//禁止滚动
var preventScroll = function(){
    if(isAndroid){
        $('html,body').css('overflow','hidden');
    }
    $('.frame').css('overflow','hidden');
}
//还原滚动
var enableScroll = function(){
    if(isAndroid){
        $('.frame').css('overflow','visible');
        $('html,body').css('overflow','auto');
    }
    else{
        $('.frame').css('overflow','auto');
    }
}

//显示/隐藏footer
var showfooter = function(actid){
    hidedoctorfooter();
    hidecirclefooter();
    hidecirclereplyfooter();
    hidechatfooter();
    $('.footer').css('display','block');
    if(actid==0){
        $('.nav_home').addClass('nav_home_active');
        $('.nav_com').removeClass('nav_com_active');
        $('.nav_circle').removeClass('nav_circle_active');
        $('.nav_my').removeClass('nav_my_active');
    }
    else if(actid==1){
        $('.nav_home').removeClass('nav_home_active');
        $('.nav_com').addClass('nav_com_active');
        $('.nav_circle').removeClass('nav_circle_active');
        $('.nav_my').removeClass('nav_my_active');
    }
    else if(actid==2){
        $('.nav_home').removeClass('nav_home_active');
        $('.nav_com').removeClass('nav_com_active');
        $('.nav_circle').addClass('nav_circle_active');
        $('.nav_my').removeClass('nav_my_active');
    }
    else if(actid==3){
        $('.nav_home').removeClass('nav_home_active');
        $('.nav_com').removeClass('nav_com_active');
        $('.nav_circle').removeClass('nav_circle_active');
        $('.nav_my').addClass('nav_my_active');
    }
    $('.mainbody').css('padding-bottom','51px');
}
var hidefooter = function(){
    hidedoctorfooter();
    hidecirclefooter();
    hidecirclereplyfooter();
    hidechatfooter();
    $('.footer').css('display','none');
    $('.mainbody').css('padding-bottom','0');
}

var showdoctorfooter = function(){
    $('.doctorfooter').css('display','block');
    $('.mainbody').css('padding-bottom','51px');
}
var hidedoctorfooter = function(){
    $('.doctorfooter').css('display','none');
    $('.mainbody').css('padding-bottom','0');
}

var showcirclefooter = function(){
    $('.circlefooter').css('display','block');
    $('.mainbody').css('padding-bottom','51px');
}
var hidecirclefooter = function(){
    $('.circlefooter').css('display','none');
    $('.mainbody').css('padding-bottom','0');
}

var showcirclereplyfooter = function(){
    $('.circlereplyfooter').css('display','block');

    if($('.nav_rpic_i').length>0) {
        $('.mainbody').css('padding-bottom', '181px');
        $('.circlereplyfooter').css('height','180px');
        $('.circlereplybg').show();
    }
    else {
        $('.mainbody').css('padding-bottom', '51px');
        $('.circlereplyfooter').css('height','50px');
        $('.circlereplybg').show();
    }
}
var hidecirclereplyfooter = function(){
    $('.circlereplyfooter').css('display','none');
    $('.mainbody').css('padding-bottom','0');
    $('.circlereplybg').hide();
}

var showchatfooter = function(){
    $('.chatfooter').css('display','block');
    $('.mainbody').css('padding-bottom', '51px');
    $('#ChatContent').val('');
}
var hidechatfooter = function(){
    $('.chatfooter').css('display','none');
    $('.mainbody').css('padding-bottom','0');
}

//显示/隐藏header
var showheader = function(title,centerindex,leftbtnindex,rightbtnindex){
    $('.header_cc,.header_ll,.header_rr').css('display','none');
    $('#SearchKeyword').val('');
    $('.header .title').text(title);
    if(centerindex!=-1)
        $('.header_cc').eq(centerindex).css('display','inline-block');
    if(leftbtnindex!=-1)
        $('.header_ll').eq(leftbtnindex).css('display','inline-block');
    if(rightbtnindex!=-1)
        $('.header_rr').eq(rightbtnindex).css('display','inline-block');

    $('.header').css('display','block');
    if(isAndroid)
        $('.mainbody').css('padding-top','56px');
    else
        $('.mainbody').css('padding-top','70px');
}
var hideheader = function(){
    $('.header').css('display','none');
    $('.mainbody').css('padding-top','0');
    //$('#mbodycontainer').css('bottom','0');
}

//显示/隐藏弹出菜单
//可带json数组为参数，设置菜单内容
//[{title:"去第一页",link:"#n1"},{title:"执行JS",link:"javascript:alert('a')"}]
var togglemenu = function(spanArr){
    if(typeof($menu)==='undefined') {
        $menu = $('.selectorlayout');
        $menubg = $('.menubglayout');
        $citycontainer=$('.citylayout');
    }
    if($menubg.is(':visible')){
        $menu.hide();//.css('opacity','0').data('show',false);
        $menubg.hide();//.css('opacity','0');
        $citycontainer.hide();
        $('.dislayout').hide();
        $('.sfe_keyword').val('');
        $('.sfe').hide();
        enableScroll();
    } else{
        var $selectorbody=$('.selectorlayout_body');
        $selectorbody.empty();
        var tmpH=Math.floor($menu.height()-48);
        $selectorbody.height(tmpH);

        //tr(typeof(spanArr));
        if(typeof(spanArr) === 'object'){
            for(var i=0;i<spanArr.length;i++){
                if(spanArr[i].link.substr(0,1)==='#')
                    $selectorbody.append('<span class="link" rel="'+spanArr[i].link+'">'+spanArr[i].title+'</span>');
                else
                    $selectorbody.append('<span class="link" on'+END_EV+'="if(moving>movingflag)return false;'+spanArr[i].link+';hidemenu();">'+spanArr[i].title+'</span>');
            }
        }
        $menu.show();
        $menubg.show();//.css('opacity','1');
        preventScroll();
    }
}
var hidemenu = function(){
    $menu = $('.selectorlayout');
    $menubg = $('.menubglayout');
    $citycontainer=$('.citylayout');
    $searchlayout=$('.searchlayout');
    //if($menu.data('show')){
    $menu.hide();//.css('opacity','0').data('show',false);
    $menubg.hide();//.css('opacity','0');
    $citycontainer.hide();
    $searchlayout.hide();
    $('.dislayout').hide();
    $('.giftlayout').hide();
    $('.noticelayout').hide();
    $('.sfe_keyword').val('');
    $('.sfe').hide();
    enableScroll();

    //}
}

var shownotice = function(title,content){
    $('.menubglayout').show();
    $('.noticelayout_title').text(title);
    $('.noticelayout_body').html(content);
    $('.noticelayout').show();
}

//新内容切入方法
var slide_in = function(html, page, target_str, cb){
    showloading('加载中');
    __sl_html=html;
    __sl_page=page;
    __sl_target_str=target_str;
    __sl_cb=cb;

    //第一页跳过检查（自带检查）
    if(page==rStart){
        doslidein(__sl_html,__sl_page,__sl_target_str,__sl_cb);
        return;
    }

    //检查网络连接
    $.getp(API_INTERFACE_CHECKCONNECT,{},true,true,true,function(json){
        doslidein(__sl_html,__sl_page,__sl_target_str,__sl_cb);
    },function(json){
        doslidein(__sl_html,__sl_page,__sl_target_str,__sl_cb);
    },function(){
        //连接失败
        Router.delselfhistory();
        do_confirm('与服务器的连接已断开，请检查网络状况', {title:'提示',choice:['取消','重试']}, function(result){
            if(result==do_confirm.OK) {
                slide_in(__sl_html,__sl_page,__sl_target_str,__sl_cb);
            }
            else{
                hideloading();
            }
        });
    });
}

var doslidein=function(html, page, target_str, cb){
    target = $(target_str);
    if (!target.length) {hideloading();showtips('找不到页面'); return }


    /* 临时-start */
    for(var i=0;i<intervalArr.length;i++){
        clearInterval(intervalArr[i]);
    }
    for(var i=0;i<intervalArr.length;i++){
        clearTimeout(timeoutArr[i]);
    }
    target.replaceWith(html);
    $('.frame').css('height',windowHeight+'px');

    if (cb) cb();
    /* 临时-end */

    /*
     if (target.length > 1) {
     for(var i=0; i<target.length-1; i++) {
     $(target[i]).remove();
     }
     target = $(target[i]);
     }
     var par = target.parent(),
     last = Router.history(-1),
     from = Router.get_position(page, last),
     new_frame = $(html);

     //tr(last, '->', page, ': ', from);

     for(var i=0;i<intervalArr.length;i++){
     clearInterval(intervalArr[i]);
     }
     for(var i=0;i<intervalArr.length;i++){
     clearTimeout(timeoutArr[i]);
     }
     if(from == 'center'){
     target.replaceWith(html);
     //target.after(html);
     //target.remove();
     if (cb) cb();
     hideloading();

     } else if (from == 'right' || from == 'left') {
     var start = par.width() * (from == 'right' ? 1:-1);
     new_frame.css('left', start);
     target.after(new_frame);
     //target.imove(-start, 0, 200, function(){target.remove();if (cb) cb();hideloading();});
     //new_frame.imove(-start, 0, 200);
     do_timeout(function(){
     target.css('left',-start);
     new_frame.css('left','0');
     },10);
     do_timeout(function(){target.remove();if (cb) cb();},220);

     } else if (from == 'bottom') {
     new_frame.css('top', par.height()).css('height', target.height());
     target.after(new_frame);
     //new_frame.imove(0, -par.height(), 200, function(){target.remove();if (cb) cb();hideloading();});
     new_frame.css('top','0');
     do_timeout(function(){target.remove();if (cb) cb();},220);

     } else if (from == 'bottom_out') {
     target.before(new_frame);
     //target.imove(0, par.height(), 200, function(){target.remove();if (cb) cb();hideloading();});
     target.css('top',par.height());
     do_timeout(function(){target.remove();if (cb) cb();},220);
     }
     */
    Router.fixhistory();
    //if (cb) cb();
    document.body.scrollTop=0;
    hideloading();
}

var do_debug = function(str){
    if(DEBUG)
        console.log(str);
}

var do_alert = function(str, title) {
    title = title || "消息";
    if(isAndroid || isIDevice) {
        navigator.notification.alert(str, function(){}, title, "确定");
    } else {
        alert(str);
    }
}
var do_confirm = function(str, config, cb) {
    if (typeof config == 'function') {
        cb = config;
        config = {};
    }
    var title = config['title'] || '提醒',
    choice = config['choice'] || ["取消","确定"];
    //if(isAndroid || isIDevice) {
        navigator.notification.confirm(str, cb, title, choice);
    //} else {
    //    cb(confirm(str) ? 2 : 1);
    //}
}
do_confirm.OK = 2;
do_confirm.CANCEL = 1;

var do_interval = function(func, time) {
    if (typeof func == 'function') {
        intervalArr[intervalArr.length]=setInterval(func, time);
    }
}
var do_timeout = function(func, time) {
    if (typeof func == 'function') {
        timeoutArr[timeoutArr.length]=setTimeout(func, time);
    }
}
intervalArr=new Array();
timeoutArr=new Array();

//手动打开hash
var handleOpenURL = function(url) {
    // invoke from AppDelegate
    location.hash = url;
}

//日期格式化方法
Date.prototype.pattern=function(fmt) {
    var o = {
        "M+" : this.getMonth()+1, //月份
        "d+" : this.getDate(), //日
        "h+" : this.getHours()%12 == 0 ? 12 : this.getHours()%12, //小时
        "H+" : this.getHours(), //小时
        "m+" : this.getMinutes(), //分
        "s+" : this.getSeconds(), //秒
        "q+" : Math.floor((this.getMonth()+3)/3), //季度
        "S" : this.getMilliseconds() //毫秒
    };
    var week = {
        "0" : "日",
        "1" : "一",
        "2" : "二",
        "3" : "三",
        "4" : "四",
        "5" : "五",
        "6" : "六"
    };
    if(/(y+)/.test(fmt)){
        fmt=fmt.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length));
    }
    if(/(E+)/.test(fmt)){
        fmt=fmt.replace(RegExp.$1, ((RegExp.$1.length>1) ? (RegExp.$1.length>2 ? "星期" : "周") : "")+week[this.getDay()+""]);
    }
    for(var k in o){
        if(new RegExp("("+ k +")").test(fmt)){
            fmt = fmt.replace(RegExp.$1, (RegExp.$1.length==1) ? (o[k]) : (("00"+ o[k]).substr((""+ o[k]).length)));
        }
    }
    return fmt;
}

//Base64
function Base64() {
    // private property
    _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

    // public method for encoding
    this.encode = function (input) {
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;
        input = _utf8_encode(input);
        while (i < input.length) {
            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);
            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;
            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }
            output = output +
            _keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
            _keyStr.charAt(enc3) + _keyStr.charAt(enc4);
        }
        return output;
    }

    // public method for decoding
    this.decode = function (input) {
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while (i < input.length) {
            enc1 = _keyStr.indexOf(input.charAt(i++));
            enc2 = _keyStr.indexOf(input.charAt(i++));
            enc3 = _keyStr.indexOf(input.charAt(i++));
            enc4 = _keyStr.indexOf(input.charAt(i++));
            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;
            output = output + String.fromCharCode(chr1);
            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }
        }
        output = _utf8_decode(output);
        return output;
    }

    // private method for UTF-8 encoding
    _utf8_encode = function (string) {
        string = string.replace(/\r\n/g,"\n");
        var utftext = "";
        for (var n = 0; n < string.length; n++) {
            var c = string.charCodeAt(n);
            if (c < 128) {
                utftext += String.fromCharCode(c);
            } else if((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            } else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }
        return utftext;
    }

    // private method for UTF-8 decoding
    _utf8_decode = function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;
        while ( i < utftext.length ) {
            c = utftext.charCodeAt(i);
            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            } else if((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i+1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            } else {
                c2 = utftext.charCodeAt(i+1);
                c3 = utftext.charCodeAt(i+2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }
        }
        return string;
    }
}

window.onerror = function(msg, url, line) {
    if(!DEBUG) return;
    var idx = url.lastIndexOf("/");
    if(idx > -1) {
        url = url.substring(idx+1);
    }
    alert("line #" + line + ": \n" + msg);
    return false;
};

var onBodyLoad = function() {
    if('ontouchstart' in window) {
        document.addEventListener('deviceready', onDeviceReady, false);
        //$(onDeviceReady);
    } else {
        $(onDeviceReady);
    }
}